#include <thread>
#include <iostream>
#include <mutex>

int globalMoney = 0;
std::mutex moneyLock;

void addMoney()
{
    for (int i=0; i<200000; i++) {
        std::lock_guard<std::mutex> g(moneyLock);
        globalMoney = globalMoney + 1;
    }
    std::cout << "Neuer Kontostand: " << globalMoney << std::endl;
}

int main(int argc, char *argv[])
{
    auto t1 = std::chrono::high_resolution_clock::now();
    std::thread thread( addMoney );
    addMoney();
    thread.join();
    auto t2 = std::chrono::high_resolution_clock::now();
    std::cout << "Kontostand: " << globalMoney << std::endl;
    std::cout << "Transaktion dauerte " << std::chrono::duration_cast<std::chrono::milliseconds>(t2-t1).count() << " ms" << std::endl;
    return 0;
}
